/**   asm_utils.h
 **
 **   This is the header file contains common definitions for the assembly
 ** usilities in module "asm_utils.S".
 **
 ** Created by Ted Schmitz, May 27, 2009
 **
 **/

extern void octeon_flush_l2_cache(void);
extern void ll_write_ram(u64 beg_adrs, u64 end_adrs, u64 spare);
extern void ll_fill_ram(u64 beg_adrs, u64 end_adrs, u64 fill_data);
extern void ll_fill_ram_16(u64 beg_adrs, u64 end_adrs, u64 fill_data);
extern void ll_ram_adrs_lines_fill_talt(u64 beg_adrs, u64 end_adrs);
extern void ll_ram_adrs_lines_fill_talt_rel(u64 beg_adrs, u64 end_adrs,
                                            u64 rel_adrs);
extern void ll_asm_adrs_lines_data_verify_talt(u64 beg_adrs, u64 end_adrs, 
                                               u64 * results_array);
extern void ll_asm_adrs_lines_data_verify_talt_rel(u64 beg_adrs, u64 end_adrs, 
                                                   u64 * results_array, 
                                                   u64 rel_adrs);
extern void ll_asm_flush_cache(u64 beg_adr, u64 length);
extern void ll_read_tlv(u64 * tlb_array);
extern void ll_write_tlv(u64 * tlb_array);
extern void ll_ram_fill_rel(u64 beg_adrs, u64 end_adrs, u64 rel_adrs,
                            u64 data_pattern);
extern void ll_asm_ram_cells_verify_rel(u64 beg_adrs, u64 end_adrs, 
                                        u64 * results_array,
                                        u64 rel_adrs,
                                        u64 exp_data);
extern void ll_asm_ram_cells_verify(u64 beg_adrs, u64 end_adrs, 
                                    u64 * results_array,
                                    u64 exp_data);
extern void ll_asm_ram_cells_16_verify(u64 beg_adrs, u64 end_adrs, 
                                        u64 * results_array,
                                        u64 exp_data);
extern void ll_asm_reset_unit(void);
extern void ll_ram_fill_16_rel(u64 beg_adrs, u64 end_adrs, u64 rel_adrs,
                               u64 data_pattern);
extern void ll_asm_ram_cells_verify_16_rel(u64 beg_adrs, u64 end_adrs, 
                                           u64 * results_array,
                                           u64 rel_adrs,
                                           u64 exp_data);
